<?php
/**
 * ApiV1TanssEventsRulesTestActionTicketNotificationOptions
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * ApiV1TanssEventsRulesTestActionTicketNotificationOptions Class Doc Comment
 *
 * @category Class
 * @description object containing infos needed for a ticket notification
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class ApiV1TanssEventsRulesTestActionTicketNotificationOptions implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = '_api_v1_tanssEvents_rules_test_action_ticketNotificationOptions';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'reason' => 'string',
        'mailId' => 'int',
        'commentId' => 'int',
        'supportId' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'reason' => null,
        'mailId' => null,
        'commentId' => null,
        'supportId' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'reason' => 'reason',
        'mailId' => 'mailId',
        'commentId' => 'commentId',
        'supportId' => 'supportId'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'reason' => 'setReason',
        'mailId' => 'setMailId',
        'commentId' => 'setCommentId',
        'supportId' => 'setSupportId'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'reason' => 'getReason',
        'mailId' => 'getMailId',
        'commentId' => 'getCommentId',
        'supportId' => 'getSupportId'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const REASON_STATUS_CHANGED = 'STATUS_CHANGED';
    public const REASON_ASSIGNED_TO_ANOTHER_TECHNICIAN = 'ASSIGNED_TO_ANOTHER_TECHNICIAN';
    public const REASON_NEW_COMMENT = 'NEW_COMMENT';
    public const REASON_NEW_SUPPORT = 'NEW_SUPPORT';
    public const REASON_TICKET_CREATED = 'TICKET_CREATED';
    public const REASON_TICKET_REMINDER = 'TICKET_REMINDER';
    public const REASON_EMAIL_RECEIVED = 'EMAIL_RECEIVED';
    public const REASON_TICKET_NOT_MORE_ASSIGNED_TO_SELF = 'TICKET_NOT_MORE_ASSIGNED_TO_SELF';
    public const REASON_NEW_SERVICE_CAP = 'NEW_SERVICE_CAP';
    public const REASON_TICKET_CLOSED = 'TICKET_CLOSED';
    public const REASON_NEW_DUE_DATE = 'NEW_DUE_DATE';
    public const REASON_NEW_DEADLINE = 'NEW_DEADLINE';
    public const REASON_CHANGED_TAGS = 'CHANGED_TAGS';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getReasonAllowableValues()
    {
        return [
            self::REASON_STATUS_CHANGED,
            self::REASON_ASSIGNED_TO_ANOTHER_TECHNICIAN,
            self::REASON_NEW_COMMENT,
            self::REASON_NEW_SUPPORT,
            self::REASON_TICKET_CREATED,
            self::REASON_TICKET_REMINDER,
            self::REASON_EMAIL_RECEIVED,
            self::REASON_TICKET_NOT_MORE_ASSIGNED_TO_SELF,
            self::REASON_NEW_SERVICE_CAP,
            self::REASON_TICKET_CLOSED,
            self::REASON_NEW_DUE_DATE,
            self::REASON_NEW_DEADLINE,
            self::REASON_CHANGED_TAGS,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['reason'] = $data['reason'] ?? null;
        $this->container['mailId'] = $data['mailId'] ?? null;
        $this->container['commentId'] = $data['commentId'] ?? null;
        $this->container['supportId'] = $data['supportId'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getReasonAllowableValues();
        if (!is_null($this->container['reason']) && !in_array($this->container['reason'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'reason', must be one of '%s'",
                $this->container['reason'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets reason
     *
     * @return string|null
     */
    public function getReason()
    {
        return $this->container['reason'];
    }

    /**
     * Sets reason
     *
     * @param string|null $reason reason of the ticket notification
     *
     * @return self
     */
    public function setReason($reason)
    {
        $allowedValues = $this->getReasonAllowableValues();
        if (!is_null($reason) && !in_array($reason, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'reason', must be one of '%s'",
                    $reason,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['reason'] = $reason;

        return $this;
    }

    /**
     * Gets mailId
     *
     * @return int|null
     */
    public function getMailId()
    {
        return $this->container['mailId'];
    }

    /**
     * Sets mailId
     *
     * @param int|null $mailId if reason is \"EMAIL_RECEIVED\", the id of the mail is given here
     *
     * @return self
     */
    public function setMailId($mailId)
    {
        $this->container['mailId'] = $mailId;

        return $this;
    }

    /**
     * Gets commentId
     *
     * @return int|null
     */
    public function getCommentId()
    {
        return $this->container['commentId'];
    }

    /**
     * Sets commentId
     *
     * @param int|null $commentId if reason is \"NEW_COMMENT\", the id of the comment is given here
     *
     * @return self
     */
    public function setCommentId($commentId)
    {
        $this->container['commentId'] = $commentId;

        return $this;
    }

    /**
     * Gets supportId
     *
     * @return int|null
     */
    public function getSupportId()
    {
        return $this->container['supportId'];
    }

    /**
     * Sets supportId
     *
     * @param int|null $supportId if reason is \"NEW_SUPPORT\", the id of the support is given here
     *
     * @return self
     */
    public function setSupportId($supportId)
    {
        $this->container['supportId'] = $supportId;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


